%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

# disable by default, mozjs185 symbols conflict with firefox and make it crash (#6299)
# see also https://bugzilla.novell.com/show_bug.cgi?id=759123
#          https://bugzilla.mozilla.org/show_bug.cgi?id=763185
%bcond_with mozjs

%define major 1
%define libname		%mklibname proxy %{major}
%define develname	%mklibname -d proxy
%define gnomename	%mklibname proxy-gnome
%define kdename		%mklibname proxy-kde
%define nmname		%mklibname proxy-networkmanager
%define mozjsname	%mklibname proxy-mozjs
%define webkitname	%mklibname proxy-webkit
%define first_biarch_version	0.4.7-2
%define _libexecdir	%{_prefix}/lib

Name:           libproxy
Version:        0.4.11
Release:        %mkrel 5
Summary:        A library handling all the details of proxy configuration

Group:          System/Libraries
License:        LGPLv2+
URL:            http://code.google.com/p/libproxy/
# http://code.google.com/p/libproxy/issues/detail?id=130&can=1&q=perl
Source0:        http://%{name}.googlecode.com/files/%{name}-%{version}.tar.gz
# (cjw) fix perl binding build: add -lpthread
Patch2:		libproxy-0.4.7-pthread.patch

BuildRequires:  cmake
BuildRequires:  python-devel
#perl
BuildRequires:  perl-devel
%if !%{bootstrap}
%if %{with mozjs}
# mozjs
BuildRequires:  pkgconfig(mozjs185)
%endif
# NetworkManager
BuildRequires:  NetworkManager-devel
BuildRequires:  dbus-glib-devel
# gnome3
BuildRequires:	glib2-devel >= 2.26
# webkit (gtk)
BuildRequires:  webkitgtk3-devel
# kde
BuildRequires:	kdelibs4-devel
BuildRequires:  libxmu-devel
%endif


%description
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package -n %{libname}
Group:System/Libraries
Summary:        A library handling all the details of proxy configuration
#Virtual Provides - We need either mozjs or WebKit
%if !%{bootstrap}
Requires: %{name}-pac >= %{version}
%endif
Obsoletes:	libproxy0
%if !%{with mozjs}
Obsoletes:     %{mklibname proxy-mozjs} < %version-%release
%endif

%description -n %{libname}
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package        utils
Summary:        Binary to test %{name}
Group:          System/Networking
Requires:       %{libname} = %{version}-%{release}

%description    utils
The %{name}-utils package contains the proxy binary for %{name}

%package -n python-%{name}
Summary:        Binding for %{name} and python
Group:          Development/Python
Requires:       %{libname} = %{version}-%{release}

%description -n python-%{name}
The python-%{name} package contains the python binding for %{name}

%package        perl
Summary:        Perl bindings for %{name}
Group:          Development/Perl
Requires:       %{libname} = %{version}-%{release}

%description    perl
This contains the perl bindings for the libproxy library.

%package	gxsettings
Summary:	Helper utility for %{name} gnome support
Group:		System/Libraries

%description gxsettings
A helper utility for %{name} gnome support.

%package -n     %{gnomename}
Summary:        Plugin for %{name} and gnome
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}
%if !%{bootstrap}
Requires:       %{nmname} = %{version}-%{release}
%endif
Requires:	%{name}-gxsettings = %{version}-%{release}
Obsoletes:	libproxy-gnome < %{first_biarch_version}
Requires:	gsettings-desktop-schemas

%description -n %{gnomename}
The %{name}-gnome package contains the %{name} plugin for gnome.

%if !%{bootstrap}
%package -n     %{kdename}
Summary:        Plugin for %{name} and kde
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}
Requires:       %{nmname} = %{version}-%{release}
Obsoletes:	libproxy-kde < %{first_biarch_version}

%description -n %{kdename}
The %{name}-kde package contains the %{name} plugin for kde.

%package -n     %{nmname}
Summary:        Plugin for %{name} and NetworkManager
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}

%description -n %{nmname}
The %{name}-networkmanager package contains the %{name} plugin for NetworkManager.

%package -n     %{mozjsname}
Summary:        Plugin for %{name} and mozjs
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
Obsoletes:	libproxy-mozjs < %{first_biarch_version}

%description -n %{mozjsname}
The %{name}-mozjs package contains the %{name} plugin for mozjs.

%package -n     %{webkitname}
Summary:        Plugin for %{name} and webkit
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
Obsoletes:	libgnome-webkit < %{first_biarch_version}

%description -n %{webkitname}
The %{name}-webkit package contains the %{name} plugin for
webkit.
%endif

%package -n %{develname}
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{develname}
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
%apply_patches

%build
%if %{bootstrap}
export CC="gcc -L$(pkg-config --variable sdkdir libxul)/lib"
%endif
# (blino) do not build pacrunner as internal (BIPR=OFF), to avoid having gtk deps in the main package
%cmake -Dlibexecdir=%{_libexecdir} -DLIBEXEC_INSTALL_DIR=%{_libexecdir} \
-DMODULE_INSTALL_DIR=%{_libdir}/%{name}/%{version}/modules \
-DBIPR=OFF \
%if !%{with mozjs}
-DWITH_MOZJS=OFF \
%endif
-DPERL_VENDORINSTALL=1 -DWITH_WEBKIT3=1
%make

%install
rm -rf %{buildroot}
cd build
%makeinstall_std
#gw fix pkgconfig file
sed -i -e "s^Version:.*^Version: %version^" %{buildroot}%{_libdir}/pkgconfig/*.pc

%clean
rm -rf %{buildroot}

%files -n %{libname}
%doc AUTHORS README
%{_libdir}/libproxy.so.%{major}*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/%{version}
%dir %{_libdir}/%{name}/%{version}/modules

%files utils
%{_bindir}/proxy

%files -n python-%{name}
%{py_sitedir}/*

%files perl
%{perl_vendorarch}/Net/Libproxy.pm
%{perl_vendorarch}/auto/Net/Libproxy

%files gxsettings
%{_libexecdir}/pxgsettings
#{_prefix}/libexec/pxgsettings

%files -n %{gnomename}
%{_libdir}/%{name}/%{version}/modules/config_gnome3.so

%if !%{bootstrap}
%files -n %{kdename}
%{_libdir}/%{name}/%{version}/modules/config_kde4.so

%files -n %{nmname}
%{_libdir}/%{name}/%{version}/modules/network_networkmanager.so

%if %{with mozjs}
%files -n %{mozjsname}
%{_libdir}/%{name}/%{version}/modules/pacrunner_mozjs.so
%endif

%files -n %{webkitname}
%{_libdir}/%{name}/%{version}/modules/pacrunner_webkit.so
%endif

%files -n %{develname}
%{_includedir}/proxy.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/libproxy-1.0.pc
%{_datadir}/cmake/Modules/Findlibproxy.cmake


%changelog
* Sat Oct 19 2013 umeabot <umeabot> 0.4.11-5.mga4
+ Revision: 524153
- Mageia 4 Mass Rebuild

* Wed May 29 2013 fwang <fwang> 0.4.11-4.mga4
+ Revision: 430416
- rebuild for new perl

* Tue Jan 22 2013 fwang <fwang> 0.4.11-3.mga3
+ Revision: 390902
- update rpm group

* Sat Jan 12 2013 umeabot <umeabot> 0.4.11-2.mga3
+ Revision: 358008
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 25 2012 luigiwalser <luigiwalser> 0.4.11-1.mga3
+ Revision: 334840
- 0.4.11

* Fri Oct 19 2012 blino <blino> 0.4.10-1.mga3
+ Revision: 308355
- drop custom patch and use new BIPR option to disable building pac runner as internal
- 0.4.10
- drop merged patches

* Thu Oct 11 2012 ovitters <ovitters> 0.4.7-10.mga3
+ Revision: 304660
- add require on gsettings-desktop-schemas (mga#7766)

* Sat Sep 08 2012 blino <blino> 0.4.7-9.mga3
+ Revision: 290383
- move obsoletes to the library package (main package is not created since it does not have any files)

* Sat Sep 08 2012 blino <blino> 0.4.7-8.mga3
+ Revision: 290347
- obsolete mozjs sub-module when disabled to automatically fix #6299 on upgrades
- fix build with gcc 4.7 (upstream r833)
- force js engine sub-module creation even if only one is enabled
- use apply_patches macro
- disable mozjs build by default, mozjs185 symbols conflict with firefox and make it crash (#6299)

* Wed May 30 2012 jquelin <jquelin> 0.4.7-7.mga3
+ Revision: 250907
- perl 5.16 rebuild

* Tue Apr 17 2012 blino <blino> 0.4.7-6.mga2
+ Revision: 231177
- require NetworkManager detection module in Gnome and KDE packages
  (it only pulls dbus as a dependency)
- add networkmanager subpackage
- add back libproxy-mozjs and libproxy-webkit packages
- mozjs: fix resolving local hostname (from upstream)
- enable networkmanager module
- enable again mozjs support using mozjs185 (patch from upstream)

* Sun Feb 19 2012 tv <tv> 0.4.7-5.mga2
+ Revision: 210753
- fix obsoletes on x86_64

* Sat Feb 18 2012 tv <tv> 0.4.7-4.mga2
+ Revision: 210510
- drop libproxy-webkit
- drop libproxy-mozjs
- do not try to build with libxulrunner
- rebuild for new xulrunner

* Sat Sep 17 2011 fwang <fwang> 0.4.7-3.mga2
+ Revision: 144519
- correct build with webkit 1.5

* Wed Jun 22 2011 cjw <cjw> 0.4.7-2.mga2
+ Revision: 112515
- allow biarch installation of modules
- put the gnome3 config helper app in /usr/lib in a separate package

* Tue Jun 21 2011 cjw <cjw> 0.4.7-1.mga2
+ Revision: 111504
- 0.4.7
- drop gnome2 module
- add gnome3 module
- drop libmodman package: it is now built into libproxy and nothing else used it
- build webkit module against webkitgtk3

* Sat Jun 11 2011 sander85 <sander85> 0.4.6-9.mga2
+ Revision: 103956
- perl 5.14

* Sun May 15 2011 pterjan <pterjan> 0.4.6-8.mga1
+ Revision: 98944
- Rebuild for fixed find-requires

* Wed Apr 20 2011 pterjan <pterjan> 0.4.6-7.mga1
+ Revision: 89143
- Use upstream fix for firefox 4

  + ennael <ennael>
    - obsoletes libproxy0 (upgrade from mdv)

* Sat Jan 22 2011 pterjan <pterjan> 0.4.6-5.mga1
+ Revision: 33136
- Fix build with firefox 4
- Disbale bootstrap

  + jquelin <jquelin>
    - rebuild

* Sat Jan 15 2011 blino <blino> 0.4.6-3.mga1
+ Revision: 18885
- bootstrap libproxy
- do not build xulrunner and kde plugins in bootstrap
- imported package libproxy


* Wed Nov 03 2010 Götz Waschk <waschk@mandriva.org> 0.4.6-2mdv2011.0
+ Revision: 592881
- rebuild for new python 2.7

* Mon Sep 06 2010 Götz Waschk <waschk@mandriva.org> 0.4.6-1mdv2011.0
+ Revision: 576217
- python module is arch-dependant
- new version
- drop patches
- new libmodman major 1

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-3mdv2011.0
+ Revision: 568091
- disable bootstrap

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-2mdv2011.0
+ Revision: 568077
- fix bootstrapping option
- bootstrap build
- fix pkgconfig file

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-1mdv2011.0
+ Revision: 568003
- new version
- new major
- add libmodman
- drop patches 1,2,3
- fix build
- add perl binding

* Sat Jan 02 2010 Götz Waschk <waschk@mandriva.org> 0.3.1-2mdv2010.1
+ Revision: 485011
- don't apply patch 3 on Cooker, fixes build

* Thu Nov 26 2009 Funda Wang <fwang@mandriva.org> 0.3.1-1mdv2010.1
+ Revision: 470293
- New version 0.3.1
- fix linkage of modules

* Mon Sep 28 2009 Olivier Blin <oblin@mandriva.com> 0.2.3-4mdv2010.0
+ Revision: 450562
- use libxul-unstable headers for jsapi.h, patch from upstream
  http://code.google.com/p/libproxy/issues/detail?id=44
- add bootstrap (from Arnaud Patard)
  fix loop libsoup->libproxy->webkitgtk-devel->libsoup

* Thu Mar 12 2009 Frederik Himpe <fhimpe@mandriva.org> 0.2.3-3mdv2009.1
+ Revision: 354376
- Rebuild for new webkit major

* Tue Feb 03 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-2mdv2009.1
+ Revision: 336801
- remove deps from the library package

* Mon Feb 02 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-1mdv2009.1
+ Revision: 336716
- fix deps
- import libproxy


* Mon Feb  2 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-1mdv2009.1
- initial package based on Fedora

* Thu Jan 22 2009 kwizart < kwizart at gmail.com > - 0.2.3-8
- Merge NetworkManager module into the main libproxy package
- Main Requires the -python and -bin subpackage 
 (splitted for multilibs compliance).

* Fri Oct 24 2008 kwizart < kwizart at gmail.com > - 0.2.3-7
- Disable Gnome/KDE default support via builtin modules.
 (it needs to be integrated via Gconf2/neon instead).

* Tue Oct 21 2008 kwizart < kwizart at gmail.com > - 0.2.3-6
- Disable Obsoletes.
- Requires ev instead of evr for optionnals sub-packages.

* Tue Oct 21 2008 kwizart < kwizart at gmail.com > - 0.2.3-5
- Use conditionals build.

* Mon Sep 15 2008 kwizart < kwizart at gmail.com > - 0.2.3-4
- Remove plugin- in the name of the packages

* Mon Aug  4 2008 kwizart < kwizart at gmail.com > - 0.2.3-3
- Move proxy.h to libproxy/proxy.h
  This will prevent it to be included in the default include path
- Split main to libs and util and use libproxy to install all

* Mon Aug  4 2008 kwizart < kwizart at gmail.com > - 0.2.3-2
- Rename binding-python to python
- Add Requires: gecko-libs >= %%{gecko_version}
- Fix some descriptions
- Add plugin-webkit package
 
* Fri Jul 11 2008 kwizart < kwizart at gmail.com > - 0.2.3-1
- Convert to Fedora spec

* Fri Jun 6 2008 - dominique-rpm@leuenberger.net
- Updated to version 0.2.3
* Wed Jun 4 2008 - dominique-rpm@leuenberger.net
- Extended spec file to build all available plugins
* Tue Jun 3 2008 - dominique-rpm@leuenberger.net
- Initial spec file for Version 0.2.2

